program OutputPCXFile;

{ ணࠬ ⥭  뢮  ࠭ PCX-䠩 }
{  - 640480256 }
{ ଠ  256- 梥⭮  ࠭ ᫥ ⨭ }
{  ⤥  ᫥ ⮬ $A  $C  ᨬ  ⮣ }
{  6 ⮢   (訥  訥) ᯮ   }
{  ⮣, ⮡  PCX-䠩 16- 梥 ० 室: }
{ 1)  ଠ     䠩 (. ) }
{ 2)  ᯮᮡ 뢮 窨  ࠭ }
{  楫    ᯮ짮 뢮  ᯮ짮- }
{  BIOS-.  室 㦭  뢮 窨  ⠭ }
{   ० ᮮ⢥騬 㭪ﬨ   GRAPH.TPU }
{  ᯮ짮 ᮮ⢥饣 ᪮ ࠩ *.BGI }
{ !  ணࠬ  ⥭  㭨ᠫ쭮, 訡筮 }
{    ਢ   ⢥ ਬ }
{ ᪮쪮 ᮢ⮢  ७ ணࠬ: }
{ 1) ᯮ אַ 뢮   }
{ 2) ᯮ ⥭ 䠩   ⠬,   }
{ ⠢: 㡭 .., ᭮᪨ ࠩ, .᭮ }
{ E-mail: const@const.krasnoyarsk.su }

uses Crt;

const
  MaxX = 640;                           { ᫮ 祪  ਧ⠫ }
  MaxY = 480;                           { ᫮ 祪  ⨪ }
  NumPal = 256 * 3 - 1;


type
  Line = array[0..MaxX] of byte;
  PLine = ^Line;
  TBlockPal = array[0..NumPal] of byte;
  PBlockPal = ^TBlockPal;
                                        { ᫮  ᪮ 뢠 }
                                        { ⠭  PCX-䠩 }
                                        {  ० 640x480x256  ⨭ }
                                        { ⠪  ࠧ }
  Header = record                       {  PCX-䠩 }
    Manuf:      byte;                   { $0A }
    Ver:        byte;                   { ଠ  ᨨ (5) }
    Code:       byte;                   { 㯯 ஢ = 1 }
    Bits:       byte;                   {    (8) }
    X1,Y1,X2,Y2:word;                   { ࠧ ⨭ }
    Hres:       word;                   { ਧ⠫쭮 ࠧ襭 ᯫ (640) }
    VRes:       word;                   { ⨪쭮 ࠧ襭 ᯫ (480) }
    Palette:    array[1..48] of byte;   {  (᫨ 16-梥⭠ ⨭) }
    Mode:       byte;                   { - ($5F) }
    Planes:     byte;                   { ⢮ ᪮⥩ (1) }
    BPLine:     word;                   {   ப (640) }
    PalInf:     word;                   { ଠ   }
    ShRes:      word;                   { ࠧ襭 ᪠ }
    SvRes:      word;                   { ------"----------- }
    Extra:      array[0..53] of byte    {  ᯮ }
  end;


var
  Pict: file of byte;
  Cnt1, Cnt3: word;
  Temp1, Temp2, Cnt2: byte;
  Buffer: PLine;
  THeader: Header;
  PHeader: array[1..SizeOf( Header )] of byte absolute THeader;
  BlockPal: PBlockPal;
  CodPal: byte;
  Name: string[12];


procedure SetVideoMode( Mode: byte ); assembler;{ ⠭ ० }
asm
        mov     al,Mode
        xor     ah,ah
        int     10h
end;

procedure SetPixel( X, Y: word; Color: byte );  { ᮢ 窨 }
inline( $58/            { pop ax }
        $5A/            { pop dx }
        $59/            { pop cx }
        $B4/$0C/        { mov ah,0Ch }
        $B7/$00/        { mov bh,0 }
        $CD/$10 );      { int 10h }

procedure SetAllPalette( Buffer: pointer ); assembler;  { ⠭ 256  }
asm
  les   dx,Buffer
  mov   ax,1012h
  mov   bx,0
  mov   cx,256
  int   10h
end;

procedure SetLine( NumLine: word );             { 뢮 ப }
var
  Cnt: word;
begin
  for Cnt := 0 to MaxX - 1 do SetPixel( Cnt, NumLine, Buffer^[Cnt] )
end;

function ReadFile: boolean;             {   뢥  ࠭ }
var
  BufPalette: PBlockPal;

begin
  Assign( Pict, Name );
  Reset( Pict );
  ReadFile := False;                    { 䠩   }
  if IOResult <> 0 then Exit;
                                        {   PCX - 䠩 }
  for Cnt2 := 1 to SizeOf( Header ) do Read( Pict, PHeader[Cnt2] );
  ReadFile := True;                     { 䠩  }
  New( Buffer );
  for Cnt3 := 0 to MaxY - 1 do begin    {   稫  ப }
    Cnt1 := 0;
    repeat
      Read( Pict, Temp1 );
      if Temp1 >= $C0 then begin        { -⥫ }
                                        {  ᪨ । }
                                        { ᯮ  $C0  ਧ }
                                        { ७ ᫥饣   }
                                        {  64 ࠧ,   }
                                        {  梥⮬,    }
                                        {  ( ) }
                                        { ⮬  訡!!! }
        Temp2 := Temp1 and $3F;         { 뤥 ᫮ ७ }
        Read( Pict, Temp1 )             {  塞  }
      end else Temp2 := 1;              { ᫮ ७ = 1 }
      for Cnt2 := 1 to Temp2 do begin   {    室 }
        Buffer^[Cnt1] := Temp1;         { ᫮  ⮢ }
        Inc( Cnt1 )
      end
    until Cnt1 >= MaxX;                 {  ப  稫 }
    SetLine( Cnt3 )                     { 뢥 ப  ࠭ }
  end;
  Read( Pict, Temp1 );                  { -  256 梥⮢ }
  Dispose( Buffer );
  New( BufPalette );
  for Cnt1 := 0 to NumPal do begin      {  ଠ   }
    Read( Pict, Temp1 );
    BufPalette^[Cnt1] := Temp1 shr 2    { ࠭   }
  end;
  SetAllPalette( BufPalette );          {  宬 ⠭   }
  Dispose( BufPalette );
  Close( Pict )
end;

begin
  Name := 'test.pcx';
  SetVideoMode( $5F );                  { ᪨ ० 640480256 }
  ReadFile;
  ReadKey;
  SetVideoMode( 3 )                     { ⥪⮢ ० 80x25x16 }
end.

